ProductManagement/Models/ErrorViewModel.cs
using System;

namespace ProductManagement.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

ProductManagement/Controllers/CategoryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Application.Commands.CategoryCommands;
using Application.Dto.Category;
using Microsoft.AspNetCore.Mvc;

namespace ProductManagement.Controllers
{
    public class CategoryController : Controller
    {
        private readonly ICreateCategoryCommand _createCategory;

        public CategoryController(ICreateCategoryCommand createCategory)
        {
            _createCategory = createCategory;
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(CategoryDto categoryDto)
        {
            _createCategory.Execute(categoryDto);
            return RedirectToAction("Create", "Product");
        }
    }
}

ProductManagement/Controllers/MakerController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Application.Commands.MakerCommands;
using Application.Dto.Maker;
using Microsoft.AspNetCore.Mvc;

namespace ProductManagement.Controllers
{
    public class MakerController : Controller
    {
        private readonly ICreateMakerCommand _createMaker;

        public MakerController(ICreateMakerCommand createMaker)
        {
            _createMaker = createMaker;
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(MakerDto makerDto)
        {
            _createMaker.Execute(makerDto);
            return RedirectToAction("Create", "Product");
        }
    }
}

ProductManagement/Controllers/ProductController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Application.Commands;
using Application.Commands.ProductCommands;
using Application.Dto.Product;
using Application.Exceptions;
using Application.Queries.ProductQueries;
using Microsoft.AspNetCore.Mvc;

namespace ProductManagement.Controllers
{
    public class ProductController : Controller
    {
        private readonly IGetProductsCommand _getProducts;
        private readonly IGetProductInsertData _getProductInsertData;
        private readonly ICreateProductCommand _createProduct;
        private readonly IGetProductCommand _getProduct;
        private readonly IEditProductCommand _editProduct;

        public ProductController(IGetProductsCommand getProducts, IGetProductInsertData getProductInsertData, 
            ICreateProductCommand createProduct, IGetProductCommand getProduct, 
            IEditProductCommand editProduct)
        {
            _getProducts = getProducts;
            _getProductInsertData = getProductInsertData;
            _createProduct = createProduct;
            _getProduct = getProduct;
            _editProduct = editProduct;
        }

        [HttpGet]
        public IActionResult Index([FromQuery] ProductQuery productQuery)
        {
            return View(_getProducts.Execute(productQuery));
        }

        [HttpGet]
        public IActionResult Create()
        {
            ViewBag.ProductInsertData = _getProductInsertData.Execute();
            return View();
        }

        [HttpPost]
        public IActionResult Create(ProductInsert productInsert)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    _createProduct.Execute(productInsert);
                    TempData["Msg"] = "Succesfully created product";
                    return RedirectToAction("Index");
                }
                catch (EntityAlreadyExistException e)
                {
                    ModelState.AddModelError(string.Empty, e.Message);
                    ViewBag.ProductInsertData = _getProductInsertData.Execute();
                    return View(productInsert);
                }
                catch (Exception e)
                {
                    TempData["Msg"] = e.Message;
                    return RedirectToAction("Index");
                }
            }
            ViewBag.ProductInsertData = _getProductInsertData.Execute();
            return View(productInsert);
        }

        [HttpGet]
        public IActionResult Edit(long Id)
        {
            try
            {
                var product = _getProduct.Execute(Id);
                ViewBag.ProductInsertData = _getProductInsertData.Execute();
                return View(product);
            }
            catch(EntityNotFoundException e)
            {
                TempData["Msg"] = e.Message;
                return RedirectToAction("index");
            }
            catch (Exception e) 
            {
                TempData["Msg"] = e.Message;
                return RedirectToAction("index");
            }
        }

        [HttpPost]
        public IActionResult Edit(long Id, ProductInsert productInsert)
        {
            productInsert.Id = Id;

            if (ModelState.IsValid)
            {
                try
                {
                    _editProduct.Execute(productInsert);
                    TempData["Msg"] = "Succesfully edited product";
                    return RedirectToAction("Index");
                }
                catch(EntityNotFoundException e)
                {
                    ModelState.AddModelError(string.Empty, e.Message);
                    ViewBag.ProductInsertData = _getProductInsertData.Execute();
                    return View(productInsert);
                }
                catch(EntityAlreadyExistException e)
                {
                    ModelState.AddModelError(string.Empty, e.Message);
                    ViewBag.ProductInsertData = _getProductInsertData.Execute();
                    return View(productInsert);
                }
                catch (Exception e)
                {
                    TempData["Msg"] = e.Message;
                    return RedirectToAction("Index");
                }
            }
            return View(productInsert);
        }
    }
}

ProductManagement/Controllers/SupplierController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Application.Commands.SupplierCommands;
using Application.Dto.Supplier;
using Microsoft.AspNetCore.Mvc;

namespace ProductManagement.Controllers
{
    public class SupplierController : Controller
    {
        private readonly ICreateSupplierCommand _createSupplier;

        public SupplierController(ICreateSupplierCommand createSupplier)
        {
            _createSupplier = createSupplier;
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(SupplierDto supplierDto)
        {
            _createSupplier.Execute(supplierDto);
            return RedirectToAction("Create", "Product");
        }
    }
}

ProductManagement/Views/Category/Create.cshtml
@model Application.Dto.Category.CategoryDto

@{
    ViewData["Title"] = "Create";
}

<h3>Create category</h3>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="CategoryName" class="control-label"></label>
                <input asp-for="CategoryName" class="form-control" />
                <span asp-validation-for="CategoryName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Create" asp-controller="Product">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

ProductManagement/Views/Maker/Create.cshtml
@model Application.Dto.Maker.MakerDto

@{
    ViewData["Title"] = "Create maker";
}

<h3>Create Maker</h3>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="MakerName" class="control-label"></label>
                <input asp-for="MakerName" class="form-control" />
                <span asp-validation-for="MakerName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Create" asp-controller="Product">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

ProductManagement/Views/Product/Create.cshtml
@model Application.Dto.Product.ProductInsert

@{
    ViewData["Title"] = "Create product";
    var categories = ViewBag.ProductInsertData.Categories;
    var suppliers = ViewBag.ProductInsertData.Suppliers;
    var makers = ViewBag.ProductInsertData.Makers;
}

<h3>Create Product</h3>

<hr />
<div class="row">
    <div class="col-md-6">
        <a asp-action="Create" asp-controller="Category" class="btn btn-info">New Category</a>
        <a asp-action="Create" asp-controller="Maker" class="btn btn-info">New Maker</a>
        <a asp-action="Create" asp-controller="Supplier" class="btn btn-info">New Supplier</a>
        <form asp-action="Create">
            <div asp-validation-summary="All" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="ProductName" class="control-label"></label>
                <input asp-for="ProductName" class="form-control" />
                <span asp-validation-for="ProductName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <textarea asp-for="Description" class="form-control"></textarea>
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label" asp-for="CategoryId"></label>
                <select asp-for="CategoryId" class="form-control"
                        asp-items="@(new SelectList(categories, "Id", "CategoryName"))"></select>
            </div>
            <div class="form-group">
                <label class="control-label" asp-for="SupplierId"></label>
                <select class="form-control" asp-for="SupplierId"
                        asp-items="@(new SelectList(suppliers, "Id", "SupplierName"))"></select>
            </div>
            <div class="form-group">
                <label class="control-label" asp-for="MakerId"></label>
                <select class="form-control" asp-for="MakerId"
                        asp-items="@(new SelectList(makers, "Id", "MakerName"))"></select>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

ProductManagement/Views/Product/Edit.cshtml
@model Application.Dto.Product.ProductInsert

@{
    ViewData["Title"] = "Edit Product";
    var categories = ViewBag.ProductInsertData.Categories;
    var suppliers = ViewBag.ProductInsertData.Suppliers;
    var makers = ViewBag.ProductInsertData.Makers;
}

<h3>Edit Product</h3>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="ProductName" class="control-label"></label>
                <input asp-for="ProductName" class="form-control" />
                <span asp-validation-for="ProductName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <textarea asp-for="Description" class="form-control"></textarea>
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="CategoryId" class="control-label"></label>  
                <select asp-for="CategoryId" class="form-control" 
                        asp-items="@(new SelectList(categories, "Id", "CategoryName"))"></select>
            </div>
            <div class="form-group">
                <label asp-for="SupplierId" class="control-label"></label>
                <select class="form-control" asp-for="SupplierId" 
                        asp-items="@(new SelectList(suppliers, "Id", "SupplierName"))"></select>
            </div>
            <div class="form-group">
                <label asp-for="MakerId" class="control-label"></label>
                <select class="form-control" asp-for="MakerId"
                        asp-items="@(new SelectList(makers, "Id", "MakerName"))"></select>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

ProductManagement/Views/Product/index.cshtml
@model IEnumerable<Application.Dto.Product.ProductDto>

@{
    ViewData["Title"] = "Products";
}

<h3>Products</h3>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.ProductName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Description)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Price)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.MakerName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.SupplierName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.CategoryName)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.ProductName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Description)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Price)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.MakerName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.SupplierName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.CategoryName)
            </td>
            <td>
                <a asp-action="Edit" asp-controller="Product" asp-route-id="@item.Id" 
                   class="btn btn-outline-info">Edit</a> 
            </td>
        </tr>
}
    </tbody>
</table>

ProductManagement/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ProductManagement</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Product" asp-action="Index">ProductManagement</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Product" asp-action="Index">Products</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @if(TempData["Msg"] != null)
            {
                <h5 style="color: green">@TempData["Msg"]</h5>
            }
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - ProductManagement - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

ProductManagement/Views/Supplier/Create.cshtml
@model Application.Dto.Supplier.SupplierDto

@{
    ViewData["Title"] = "Create";
}

<h3>Create Supplier</h3>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="SupplierName" class="control-label"></label>
                <input asp-for="SupplierName" class="form-control" />
                <span asp-validation-for="SupplierName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Create" asp-controller="Product">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}